var sortindex = 0;
var sortdir = 0; // 0 = low -> high, 1 = high -> low

function colCompare(a, b) {
  var rv;
  if (a[sortindex] == b[sortindex])
    rv = 0;
  else 
    rv = (a[sortindex] > b[sortindex]) ? 1 : -1;
  //     alert("Comparing " + a[0] + "(" + a[sortindex] + ")" + " > " + b[0] + "(" + b[sortindex] + ")" + " at " + sortindex + " == " + rv);
  return sortdir ? rv : -rv;
}

function formatString(s, form) {
  switch (form) {
  case "percent" :
    s *= 100;
    s = Math.round(s);
    return s + "%";
    break;
  case "int" :    
  case "string" :		
  default :
    return s;
    break;
  }
  return s;
}

function totalVal(s, form) {
  switch (form) {
  case "percent" :
  case "string" :
  case "int_nototal" :
    return "";
  case "int" :    
  default :
    return s;
    break;
  }
  return s;
}

// attaches properties to a layer
function bindLayer(stats, stats_header, stats_print, layername) {
  window.document.layers[layername].stats = stats;
  window.document.layers[layername].stats_header = stats_header;
  window.document.layers[layername].stats_print = stats_print;   
}

// stats - array of statistics
// stats_header - header for statistics
// stats_print - way to print each column
// doc - the document we're writing to... should be a window
// layername - name for layer we're writing to
// n - column clicked on        
function makeTable(doc, layername, n) {
  var stats =            window.document.layers[layername].stats;
  var stats_header =     window.document.layers[layername].stats_header;
  var stats_print =      window.document.layers[layername].stats_print;
  var align;
  var celltype;
  var celldata;
  var totals = new Array(stats_header.length);
  totals[0] = "Total";
  for (j = 1; j < totals.length; j++)
    totals[j] = 0;
  sortdir = (n == sortindex) ? !sortdir : 0;
  sortindex = n;
  stats.sort(colCompare);
  doc.write("<center><table border=1 width=\"80%\">\n");
  doc.write("<tr>\n");
  for (j = 0; j < stats_header.length; j++) {
    doc.write("<th><a href=\"#here\" onClick='return makeTable(window.document.layers[\"", layername, "\"].document, \"", layername, "\", ", j, ");'>", stats_header[j], "</a></th>");
  }
  doc.write("</tr>\n");
  for (i = 0; i < stats.length; i++) {
    doc.write("<tr>\n");
    for (j = 0; j < stats[i].length; j++) {
      align = (j == 0) ? "center" : "right";
      celltype = (j == 0) ? "th" : "td";
      celldata = formatString(stats[i][j], stats_print[j]);
      if (j == n)
	celldata = "<font color=yellow>" + celldata + "</font>";
      doc.write("<", celltype, " align=", align, ">", celldata,
		"</", celltype, ">\n");
      if (j != 0)
	totals[j] += stats[i][j];
    }
    doc.write("</tr>\n");
  }
  doc.write("<tr>\n");
  for (j = 0; j < totals.length; j++) {
    align = (j == 0) ? "center" : "right";
    celltype = (j == 0) ? "th" : "td";
    celldata = (j == 0) ? "<font color=#8080FF>Total</font>" : totalVal(totals[j], stats_print[j]);
    doc.write("<", celltype, " align=", align, ">", "<font color=#ff8000>", celldata, "</font>",
	      "</", celltype, ">\n");
  }
  doc.write("</table></center>\n");
  doc.close();
  return false;
}         
